#!/bin/bash
#set -x

USER_NAME=$(who | grep tty$(sudo fgconsole) | cut -f1 -d' ')
USER_ID=$(id -u "$USER_NAME")
HDMI_STATUS=$(</sys/class/drm/card*/*HDMI*/status)

export LANG=C
export PULSE_SERVER="unix:/run/user/$USER_ID/pulse/native"


INTERNAL_CARD=''
INTERNAL_PROFILE="analog-stereo"

HDMI_INTERNAL_CARD=''
HDMI_INTERNAL_PROFILE='hdmi-stereo-extra1'

HDMI_CARD=''
HDMI_PROFILE='hdmi-stereo'

function pactl_cmd() {
  sudo -u $USER_NAME pactl --server $PULSE_SERVER $*
}

function parse_result(){
  local name

  while read line; do
    name=`echo $line  |cut -d'"' -f2`
    echo $name
    if [ "$name" = "HDA Loongson" ];then
      INTERNAL_CARD=`echo $line  |cut -d'"' -f4 | sed 's/:/_/g'`
    elif [ "$name" = "HDA Loongson HDMI" ];then
      HDMI_INTERNAL_CARD=`echo $line  |cut -d'"' -f4 | sed 's/:/_/g'`
    else
      HDMI_CARD=`echo $line  |cut -d'"' -f4 | sed 's/:/_/g'`
    fi
  done
}

parse_result < <(awk 'NR%2{printf "%s ",$0;next;}1' < <(pactl_cmd list cards  |grep -E 'alsa.card_name|device.bus_path'| cut -d= -f2))

if [ "$HDMI_STATUS" = "connected" ]; then
  if [ -z "$HDMI_CARD" ];then
    CARD=$HDMI_INTERNAL_CARD
    OUTPUT=$HDMI_INTERNAL_PROFILE
  else
    CARD=$HDMI_CARD
    OUTPUT=$HDMI_PROFILE
  fi

  pactl_cmd set-card-profile alsa_card.$INTERNAL_CARD input:$INTERNAL_PROFILE
  pactl_cmd set-card-profile alsa_card.$CARD output:$OUTPUT
else
  CARD=$INTERNAL_CARD
  OUTPUT=$INTERNAL_PROFILE

  pactl_cmd set-card-profile alsa_card.$CARD output:$OUTPUT+input:$INTERNAL_PROFILE
  if [ -z "$HDMI_CARD" ];then
    pactl_cmd set-card-profile alsa_card.$HDMI_INTERNAL_CARD off
  else
    pactl_cmd set-card-profile alsa_card.$HDMI_CARD off
  fi
fi
exit 0
